#include "usgard.h"

.org 0
.db "Basic sprite",0

Start:
	ld      HL, &xVar
	rst     20h
	rst     10h
	ret     c
	call    &ConvBCD
	cp      127
	ret     nc
	ld      (&XPos), A
	ld      HL, &yVar
	rst     20h
	rst     10h
	ret     c
	call    &ConvBCD
	cp      57
	ret     nc
	ld      (&YPos), A
	ld      HL, &SIVar
	rst     20h
	rst     10h
	ret     c
	ex      DE, HL
	inc     HL
	inc     HL
	ld	B, 8
	ld	DE, &Sprite
ConvSprite:
	sub	A
	ld	(DE), A
	ld	A, (HL)
	sub	'A'
	rlca
	rlca
	rlca
	rlca
	ld	(DE), A
	inc	HL
	ld	A, (HL)
	sub	'A'
	ld	C, A
	ld	A, (DE)
	or	C
	ld	(DE), A
	inc	HL
	inc	DE
	djnz	ConvSprite

;HL now points to numeric info = sprite
	ld      BC, (&YPos)
	ld      HL, &Sprite
	ld      DE, VIDEO_MEM
convdone:
	ld      A, 63
	sub     C
	ld      C, A
      push hl
      push hl
      call FIND_PIXEL
      add hl,de
      ex de,hl
      pop ix
      ld  BC, $0808
      ex de,hl
PS_NewRow:
      push bc
      ld d,(ix)
      inc ix
      push af
      push hl
PS_NewCol:
      rl d
      ld e,a
      jr nc,PS_NoPixel
      or (hl)
      ld (hl),a
      jr PS_NextPixel
PS_NoPixel:
      cpl
      and (hl)
      ld (hl),a
PS_NextPixel:
      ld a,e
      rrca
      jr nc,PS_SameByte
      inc hl
PS_SameByte:
      djnz PS_NewCol
      pop hl
      pop af
      ld de,16
      add hl,de
      pop bc
      dec c
      jr nz,PS_NewRow
      pop hl
	ret

ConvBCD:
	ex      DE, HL
	inc     HL              ;skip size
	ld      D, (HL)         ;get exponent
	inc     HL              ;skip $FC byte
	inc     HL
	ld      A, (HL)
	and     $F0
	rrca
	rrca
	rrca
	rrca
	dec     D
	inc     D
	ret     z
	call    &Number
	ld	C, A
	ld      A, (HL)
	and	$0F
	add     A, C
	dec     D
	ret     z
	call    &Number
	inc     HL
	ld      C, A
	ld      A, (HL)
	rrca
	rrca
	rrca
	rrca
	add     A, C
	ret

Number:
	rlca                    ;multiply current number by 10
	ld      C, A
	rlca
	rlca
	add     A, C
	ret


xVar:
	.db 0,1,"x"
yVar:
	.db 0,1,"y"
SIVar:
	.db $0C,2,"SI"
YPos:   .db 0
XPos:   .db 0
Sprite:
 .db 0,0,0,0,0,0,0,0

.end
